##########################################################################
#                                                                        #
#           copyright (c) 2003 ITB, Humboldt-University Berlin           #
#           written by: Raphael Ritz, r.ritz@biologie.hu-berlin.de       #
#                                                                        #
##########################################################################

"""Manual reference class"""

from Products.CMFCore import CMFCorePermissions

from Products.Archetypes.public import registerType
from Products.Archetypes.public import Schema
from Products.Archetypes.public import StringField, StringWidget

from Products.CMFBibliographyAT.content.base import BaseEntry
from Products.CMFBibliographyAT.content.schemata \
    import HeaderSchema, AuthorSchema, CoreSchema, TrailingSchema
from Products.CMFBibliographyAT.content.fields \
    import organizationField, addressField, editionField


SourceSchema = Schema((
    organizationField,
    addressField,
    editionField,
     ))

ManualSchema = HeaderSchema + AuthorSchema + CoreSchema +  \
               SourceSchema + TrailingSchema


class ManualReference(BaseEntry):
    """ content type to make reference to a manual.
    """
    archetype_name = "Manual Reference"
    source_fields = ('organization', 'address', 'edition')

    schema = ManualSchema

    def Source(self):
        """ the default manual source format
        """
        try:
            return self.ManualSource()
        except AttributeError:
            return self.portal_type


registerType(ManualReference)
