##########################################################################
#                                                                        #
#           copyright (c) 2003 ITB, Humboldt-University Berlin           #
#           written by: Raphael Ritz, r.ritz@biologie.hu-berlin.de       #
#                                                                        #
##########################################################################

"""Mastersthesis reference main class"""

from Products.Archetypes.public import Schema
from Products.Archetypes.public import StringField, StringWidget
from Products.Archetypes.public import registerType

from Products.CMFBibliographyAT.content.base import BaseEntry
from Products.CMFBibliographyAT.content.schemata \
    import HeaderSchema, AuthorSchema, CoreSchema, TrailingSchema
from Products.CMFBibliographyAT.content.fields \
    import schoolField, addressField


SourceSchema = Schema((
    schoolField,
    addressField,
     ))

MastersthesisSchema = HeaderSchema + AuthorSchema + CoreSchema +  \
                      SourceSchema + TrailingSchema


class MastersthesisReference(BaseEntry):
    """ content type to make reference to a masters thesis.
    """
    archetype_name = "Mastersthesis Reference"
    source_fields = ('school', 'address')

    schema = MastersthesisSchema

    def Source(self):
        """ the default masters thesis source format
        """
        try:
            return self.MastersthesisSource()
        except AttributeError:
            return self.portal_type


registerType(MastersthesisReference)
