##########################################################################
#                                                                        #
#           copyright (c) 2003 ITB, Humboldt-University Berlin           #
#           written by: Raphael Ritz, r.ritz@biologie.hu-berlin.de       #
#                                                                        #
##########################################################################

"""Techreport reference main class"""

from Products.Archetypes.public import Schema
from Products.Archetypes.public import StringField, StringWidget
from Products.Archetypes.public import registerType

from Products.CMFBibliographyAT.content.base import BaseEntry
from Products.CMFBibliographyAT.content.schemata \
    import HeaderSchema, AuthorSchema, CoreSchema, TrailingSchema
from Products.CMFBibliographyAT.content.fields \
    import institutionField, typeField, numberField, addressField


SourceSchema = Schema((
    institutionField,
    typeField,
    numberField,
    addressField,
    ))

TechreportSchema = HeaderSchema + AuthorSchema + CoreSchema +  \
                   SourceSchema + TrailingSchema


class TechreportReference(BaseEntry):
    """ content type to make reference to a technical report.
    """
    archetype_name = "Techreport Reference"
    source_fields = ('institution', 'type', 'number', 'address')

    schema = TechreportSchema

    def Source(self):
        """ the default technical report source format
        """
        try:
            return self.TechreportSource()
        except AttributeError:
            return self.portal_type


registerType(TechreportReference)
